<template>
  <article class="view view--gallery-images">
    <div class="gallery-images">
      <div class="gallery-images__album-list">
        <AlbumList
          :username="username"
          :albums="albums"
          view="sidebar"
          :alias="alias"
          :loading="loading"
          :selecting="selectingWithPermission"
          @album-selected="onAlbumSelected"
        />
      </div>
      <div class="gallery-images__image-list">
        <ImageList
          :username="username"
          :albums="albums"
          :alias="alias"
          :selecting="selectingWithPermission"
          @stale="onStale"
        />
      </div>
    </div>
  </article>
</template>

<script>
import { ref, computed, onMounted, onUpdated } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import AlbumsApi from '../../api/albums-api.js'
import AlbumList from '../../components/album-list.vue'
import ImageList from '../../components/image-list.vue'

export default {
  name: 'GalleryImagesView',
  emits: ['albumLoaded'],
  components: {
    AlbumList,
    ImageList,
  },
  setup(_, context) {
    const route = useRoute()
    const router = useRouter()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const albumsApi = new AlbumsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const album = ref(undefined)
    const albums = ref([])

    const username = computed(() => {
      return ValidationHelper.getString(route.params.username, '')
    })

    const alias = computed(() => {
      return ValidationHelper.getString(route.params.alias, '')
    })

    const selecting = computed(() => {
      return ValidationHelper.getBoolean(route.query.selecting, false) && Boolean(store.state.gallery.formName)
    })

    const albumDisplayName = computed(() => {
      return album.value ? album.value.displayName : alias.value
    })

    const title = computed(() => {
      return selecting.value ? 'Select image(s)' : `${username.value}'s Gallery - ${albumDisplayName.value}`
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Users',
          route: { name: 'identity-users' },
        },
        {
          text: username.value,
          route: username.value ? { name: 'identity-user-profile', params: { username: username.value } } : null,
        },
        {
          text: 'Gallery',
          route: username.value
            ? {
                name: 'gallery-albums',
                params: { username: username.value },
                query: { selecting: selecting.value ? 'true' : undefined },
              }
            : null,
        },
        {
          text: albumDisplayName.value,
          route: null, // No link to self
        },
      ]
    })

    const selectingWithPermission = computed(() => {
      return selecting.value && store.state.identity.session.userId > 0
    })

    const onAlbumLoaded = (album) => {
      album.value = album
    }

    const onAlbumSelected = (album) => {
      router.push({
        name: 'gallery-images',
        params: { username: username.value, alias: album.alias },
        query: { selecting: selecting.value ? 'true' : undefined },
      })
    }

    const onStale = async () => {
      loadAsync()
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    }

    // It might seem a bit weird that we're loading albums in the gallery-images component,
    // but we need albums for the side-bar.
    // We'll load the images in the image-list component.
    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      albums.value = []

      try {
        const response = await albumsApi.fetchAsync({
          username: username.value,
          expand: 'all',
          offset: 0,
          limit: 0, // Don't paginate.
        })

        albums.value = response.data
        loaded.value = true

        const album = albums.value.find((a) => a.alias === alias.value)
        if (album) {
          context.emit('albumLoaded', album)
        }
      } catch (ex) {
        notify.error('There was a problem getting the albums.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    })

    onUpdated(async () => {
      if (album.value && album.value.alias != alias.value) {
        await loadAsync()
      }

      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    })

    return {
      loading,
      loaded,
      album,
      albums,
      username,
      alias,
      selecting,
      albumDisplayName,
      title,
      breadcrumbs,
      selectingWithPermission,
      onAlbumLoaded,
      onAlbumSelected,
      onStale,
    }
  },
}
</script>

<style lang="scss">
@use '../../../core/sass/vars';

.gallery-images {
  display: flex;
}

.gallery-images__album-list {
  margin-right: vars.$gallerySpacing;
}

.gallery-images__image-list {
  flex-grow: 1;
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .gallery-images__album-list {
    margin-right: vars.$gallerySpacingLarge;
  }
}
</style>
